# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_name_sub = "pf7"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "http://www.photofiltre-studio.com/pf7-en.htm"

    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "a", proxies=proxies, timeout=10):
        if bin_name_sub in bs_search["href"]:
            version = bs_search["href"].split("/")[-1].split("-")[-1].replace(".zip", "")
            latest_bin = bs_search["href"].split("/")[-1]
            download_url = bs_search["href"]
            break

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    if isfile(latest_bin):
        remove_file(latest_bin)

    print("Downloading: %s" % latest_bin)
    wget(download_url, latest_bin, proxies=proxies)
    # Checking version from file
    unzip(latest_bin)
    dir_names = glob.glob("pf7*")
    for folder in dir_names:
        if ".zip" not in folder:
            version_from_file = get_version_from_binary(makepath(folder, "Photofiltre7", "PhotoFiltre7.exe"), property_name="FileVersion")

    # if not version_from_file.startswith(version) and version_from_file != '':
    if Version(version_from_file) != Version(version) and version_from_file != "":
        version = version_from_file
    else:
        print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))

    remove_tree(latest_bin.split(".zip")[0])
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return result
